<img alt="~ Presta" src="https://user-images.githubusercontent.com/4732330/121911427-60eb0180-ccf5-11eb-9c86-fcc74c0a6a51.png" width="50px" />

# The minimalist serverless-first web framework for SSG, SSR, API endpoints and more.

> `presta` is in active development. Questions, comments, ideas? Open an issue or PR!

From HTML pages to serverless APIs, Presta's low level APIs mean you can build pretty much anything. Few opinions means you bring your own. Use any templating or serverless utility library you like.

#### Features

- Outputs _zero_ client-side Javascript — fast by default
- Fast AF, powered by [esbuild](https://esbuild.github.io/)
- Generate any file type. Easily nest microsites.
- Hybrid - make pages static, dynamic, or a mix of both
- Get started in seconds, right from the command line. Scale to thousands of pages.
- <1500 loc — and we aim to keep it that way

#### Try it now

You can try Presta right now using `npx`:

```bash
$ npx presta watch page.js
```

Then just follow [the pages guide](https://presta.run/tutorial/pages/) to create your first page.

## Getting Started

For most projects, you'll want to install locally:

```bash
$ npm i presta -D
```

## Docs

Head over to [the docs site](https://presta.run) to get started.

## Contributing

We'd love your help getting Presta to `v1.0.0`. Have a look at the [contributing](https://github.com/sure-thing/presta/blob/master/CONTRIBUTING.md) doc or say hello in a [new Issue](https://github.com/sure-thing/presta/issues). Also please review our [code of conduct](https://github.com/sure-thing/presta/blob/master/CODE_OF_CONDUCT.md).

## License

MIT License © [Sure Thing](https://github.com/sure-thing)
